#!/usr/bin/env python2

import os

from test_helpers import (FieldDetails, ISFDBSubmissionsTestCase, ISFDB_2019_10_19_Mixin,
                          ModeratorActionsFailAsNonModeratorMixin,
                          parse_change_table, verify_button_link,
                          load_xml_file)


class TestPvUpdate(ISFDB_2019_10_19_Mixin, ModeratorActionsFailAsNonModeratorMixin,
                   ISFDBSubmissionsTestCase):

        script = os.path.join(os.path.dirname(__file__), '..', 'pv_update.py')
        xml_filename = 'pubupdate.xml'
        sub_type = 4

        def test_pv_update_as_moderator(self):
                soup = self.run_script_as_user([self.script, str(self.sub_id)],
                                               run_as='moderator')
                self.assertEqual('Proposed Publication Update Submission',
                                 soup.title.text)
                # raw_table = soup.select_one('table.generic_table') # bs4
                raw_table = soup.find('table', {'class': 'generic_table'})
                changed, unchanged = parse_change_table(raw_table)
                self.assertEqual([u'Authors', u'Catalog ID', u'Date', u'External IDs',
                                  u'Format', u'ISBN', u'Image', u'Pages', u'Price',
                                  u'Pub Series', u'Pub Series #', u'Pub Type',
                                  u'Publisher', u'Title', u'Transliterated Title'],
                                 sorted(unchanged.keys()))
                self.assertEqual({u'Note':
                                  FieldDetails(current=u"''Greyhawk'' setting.",
                                               proposed=u"''Greyhawk'' setting.\nThis is a test edit.",
                                               # Next line is "++This is a test edit." in bs4
                                               warning=u'+ +This is a test edit.')},
                                 changed)

                self.verify_hold_and_approval_buttons(soup,
                                                      '/cgi-bin/mod/pa_update.cgi')
